package mrl.common.comparator;

import mrl.ambulance.structures.ValuableVictim;
import mrl.communication.Packet;
import mrl.helper.EdgeHelper;
import mrl.partition.Partition;
import mrl.police.moa.Target;
import mrl.world.object.FireCluster;
import mrl.world.routing.path.Path;
import rescuecore2.misc.Pair;
import rescuecore2.standard.entities.Edge;
import rescuecore2.standard.entities.Road;
import rescuecore2.standard.entities.StandardEntity;
import rescuecore2.worldmodel.EntityID;

import java.util.Comparator;

/**
 * User: mrl
 * Date: May 6, 2010
 * Time: 7:05:42 PM
 */
public class ConstantComparators {

//    public static java.util.Comparator<FireCluster> FIRE_CLUSTER_VALUE_COMPARATOR = new java.util.Comparator<FireCluster>() {
//        public int compare(FireCluster f1, FireCluster f2) {
//            if (f1.getValue() > f2.getValue())
//                return 1;
//            if (f1.getValue() == f2.getValue())
//                return 0;
//
//            return -1;
//        }
//    };


    public static Comparator<StandardEntity> ID_COMPARATOR = new Comparator<StandardEntity>() {
        public int compare(StandardEntity r1, StandardEntity r2) {

            if (r1.getID().getValue() > r2.getID().getValue())
                return 1;
            if (r1.getID().getValue() == r2.getID().getValue())
                return 0;

            return -1;
        }
    };
    public static Comparator<EntityID> EntityID_COMPARATOR = new Comparator<EntityID>() {
        public int compare(EntityID r1, EntityID r2) {

            if (r1.getValue() > r2.getValue())
                return 1;
            if (r1.getValue() == r2.getValue())
                return 0;

            return -1;
        }
    };
    public static Comparator<Path> PATH_ID_COMPARATOR = new Comparator<Path>() {
        public int compare(Path r1, Path r2) {

            if (r1.getId().getValue() > r2.getId().getValue())
                return 1;
            if (r1.getId().getValue() == r2.getId().getValue())
                return 0;

            return -1;
        }
    };
    public static Comparator<Integer> VALUE_COMPARATOR = new Comparator<Integer>() {
        public int compare(Integer r1, Integer r2) {

            if (r1 < r2)
                return 1;
            if (r1.equals(r2))
                return 0;

            return -1;
        }
    };

    public static Comparator<Partition> PARTITION_ID_COMPARATOR = new Comparator<Partition>() {
        public int compare(Partition r1, Partition r2) {

            if (r1.getId() > r2.getId())
                return 1;
            if (r1.getId() == r2.getId())
                return 0;

            return -1;
        }
    };

    public static Comparator<FireCluster> FIRE_CLUSTER_VALUE_COMPARATOR = new Comparator<FireCluster>() {
        public int compare(FireCluster f1, FireCluster f2) {

            if (f1.getValue() > f2.getValue())
                return 1;
            if (f1.getValue() == f2.getValue())
                return 0;

            return -1;
        }
    };

    public static Comparator<Edge> EDGE_LENGTH_COMPARATOR = new Comparator<Edge>() {
        public int compare(Edge e1, Edge e2) {
            int l1 = EdgeHelper.getEdgeLength(e1);
            int l2 = EdgeHelper.getEdgeLength(e2);
            if (l1 < l2)
                return 1;
            if (l1 == l2)
                return 0;

            return -1;
        }
    };
    public static Comparator<Pair<EntityID, Integer>> BID_VALUE_COMPARATOR = new Comparator<Pair<EntityID, Integer>>() {
        public int compare(Pair<EntityID, Integer> o1, Pair<EntityID, Integer> o2) {
            int l1 = o1.second();
            int l2 = o2.second();
            if (l1 < l2)       //decrease
                return 1;
            if (l1 == l2)
                return 0;

            return -1;
        }
    };

    public static Comparator<ValuableVictim> VALUABLE_VICTIM_COMPARATOR = new Comparator<ValuableVictim>() {
        public int compare(ValuableVictim o1, ValuableVictim o2) {
            double l1 = o1.getCaop();
            double l2 = o2.getCaop();
            if (l1 < l2)       //decrease
                return 1;
            if (l1 == l2)
                return 0;

            return -1;
        }
    };

    public static Comparator<Pair<EntityID, Integer>> DISTANCE_VALUE_COMPARATOR = new Comparator<Pair<EntityID, Integer>>() {
        public int compare(Pair<EntityID, Integer> o1, Pair<EntityID, Integer> o2) {
            int l1 = o1.second();
            int l2 = o2.second();
            if (l1 > l2) //Increase
                return 1;
            if (l1 == l2)
                return 0;

            return -1;
        }
    };

public static Comparator<Pair<Road, Integer>> DISTANCE_ENTRANCE_VALUE_COMPARATOR = new Comparator<Pair<Road, Integer>>() {
        public int compare(Pair<Road, Integer> o1, Pair<Road, Integer> o2) {
            int l1 = o1.second();
            int l2 = o2.second();
            if (l1 > l2) //Increase
                return 1;
            if (l1 == l2)
                return 0;

            return -1;
        }
    };


    public static Comparator<int[]> COST_VALUE_COMPARATOR = new Comparator<int[]>() {
        public int compare(int[] o1, int[] o2) {
            int l1 = o1[1];
            int l2 = o2[1];
            if (l1 > l2) //Increase
                return 1;
            if (l1 == l2)
                return 0;

            return -1;
        }
    };


    public static Comparator<Packet> PACKET_CL_VALUE_COMPARATOR = new Comparator<Packet>() {  //nozooli
        public int compare(Packet p1, Packet p2) {
            double b1 = p1.getCLPacketValue();
            double b2 = p2.getCLPacketValue();
            if (b1 < b2)
                return 1;
            if (b1 == b2)
                return p1.compareTo(p2);

            return -1;
        }
    };



}
