package mrl.partitioning;

import javolution.util.FastMap;
import rescuecore2.worldmodel.EntityID;

import java.util.List;
import java.util.Map;

/**
 * This implementation of {@link IPartitionNeededAgentsComputation} reports need of "1" agent for each partition.<br/>
 * <b>Note:</b> Use only for debugging.
 */
public class SingularPartitionNeededAgentsComputation implements IPartitionNeededAgentsComputation {

    @Override
    public Map<EntityID, Integer> computeNeededAgents(List<Partition> partitions, int agents) {
        Map<EntityID, Integer> neededAgentMap = new FastMap<EntityID, Integer>();
        for (Partition partition : partitions) {
            neededAgentMap.put(partition.getId(), 1);
        }
        return neededAgentMap;
    }
}
