package mrl.police.strategies;

import mrl.helper.RoadHelper;
import mrl.platoon.MrlPlatoonAgent;
import mrl.police.PoliceConditionChecker;
import mrl.police.PoliceMessageHelper;
import mrl.police.moa.PoliceForceUtilities;
import mrl.task.Task;
import mrl.world.MrlWorld;
import rescuecore2.worldmodel.EntityID;

import java.util.ArrayList;
import java.util.List;

/**
 * User: Pooya
 * Date: 3/1/12
 * Time: 8:10 PM
 */
public abstract class PoliceStrategy {

    protected MrlWorld world;
    protected MrlPlatoonAgent self;
    protected PoliceForceUtilities utilities;
    protected PoliceConditionChecker conditionChecker;
    protected PoliceMessageHelper messageHelper;
    RoadHelper roadHelper;

    protected Task myTask;
    protected boolean inPartition;

    public PoliceStrategy(boolean inPartition, PoliceMessageHelper messageHelper, MrlWorld world, PoliceForceUtilities utilities, PoliceConditionChecker conditionChecker, MrlPlatoonAgent self) {
        this.inPartition = inPartition;
        this.messageHelper = messageHelper;
        this.world = world;
        this.utilities = utilities;
        this.conditionChecker = conditionChecker;
        this.self = self;
        roadHelper = world.getHelper(RoadHelper.class);
    }

    public abstract Task act() ;
}
